{

functions for manipulating fido data
(c) 1999-2000 by raVen

supported compilers: borland pascal 7.0, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
unit rFido;
interface
Uses rAbs, rTpl, rFtnOut;
{}
 function IsFidoAddr(s: String): Boolean;
 {-is it a fido address? }

 function ViaDate: String;
 {-date for @Via kludge }

 function GetBSOName(Address,MainDir,What: String; MainZone: Word; Attr: tOutFlavor): String;
 {-get bink style outbound file name }

 function FileBox(BaseDir,Address: String; LongBox: Boolean): String;
 {-get t-mail filebox name (from t-api) }

 function HoldFileBox(BaseDir,Address: String; LongBox: Boolean): String;
 {-get t-mail hold filebox name (from t-api) }

 function ItAddrMask(Addr: String): Boolean;
 {-true if Addr - ftn address mask }

 function CheckMaskAddress(Mask, AddrStr: String): Boolean;
 {-true if AddrStr falls under Mask }

 function TruncateAddr(s: String): String;
 {-truncate nodes pointzero from addr }

 function DeTruncateAddr(s: String): String;
 {-add nodes pointzero to addr }

{}
implementation
uses
 rCommon, rStrings, Dos, Objects, rObjects, Strings;
{}
function    IsFidoAddr(s: String): Boolean;
 begin
  IsFidoAddr:=(CToN(ExtractWord(1,S,[DualPoint]))<>0) and
  (CToN(ExtractWord(2,S,[DualPoint,Slash]))<>0) and (Pos(Slash,S)>0);
 end;
{}
function    ViaDate: String;
 var
  ya,mo,da,dow,
  ho,mi,se,hund: Word;
 begin
  GetDate(ya,mo,da,dow);
  GetTime(ho,mi,se,hund);
  ViaDate:=Masyamba+LeadZero(ya,4)+LeadZero(mo,2)+LeadZero(da,2)+'.'+LeadZero(ho,2)+LeadZero(mi,2)+LeadZero(se,2);
 end;
{}
function    GetBSOName(Address,MainDir,What: String; MainZone: Word; Attr: tOutFlavor): String;
 const
  Zone: Word = 0;
  Node: Word = 0;
  Net: Word = 0;
  Point: Word = 0;
  AttrS: Array[1..5] of Char = 'ocdhi';
  AttrA: Array[1..5] of Char = 'fcdhi';
  AttrB: Array[1..5] of Char = 'bcccc';
 var
  s: String;
  c: Char;
 begin
  c:=AttrS[Byte(Attr)+1];
  if UpStr(What)='UT' then c:=AttrS[Byte(Attr)+1];
  if UpStr(What)='LO' then c:=AttrA[Byte(Attr)+1];
  if UpStr(What)='SY' then c:=AttrB[Byte(Attr)+1];
  What[0]:=#2;
  MainDir:=RemoveBackSlash(MainDir);
  Zone:=CToN(ExtractWord(1,Address,FidoChars));
  Net:=CToN(ExtractWord(2,Address,FidoChars));
  Node:=CToN(ExtractWord(3,Address,FidoChars));
  Point:=CToN(ExtractWord(4,Address,FidoChars));
  if Zone<>MainZone then
   begin
    s:=HexL(Zone);
    Delete(s,1,4);
    if s[1]<>'0' then
    s[0]:=#3
    else Delete(s,1,1);
    s:='.'+s;
   end else s:='';
  MainDir:=MainDir+s+BackSlash;
  s:=HexL(Net);
  Delete(s,1,4);
  MainDir:=MainDir+s;
  s:=HexL(Node);
  Delete(s,1,4);
  MainDir:=MainDir+s;
  if Point<>0 then
   begin
    MainDir:=MainDir+'.pnt\'+HexL(Point)+'.'+c+what;
   end else MainDir:=MainDir+'.'+c+what;
  GetBSOName:=MainDir;
 end;
{}
function    FileBox(BaseDir,Address: String; LongBox: Boolean): String;
 const
  Zone : Word = 0;
  Node : Word = 0;
  Net  : Word = 0;
  Point: Word = 0;
 begin
  Zone:=CToN(ExtractWord(1,Address,FidoChars));
  Net:=CToN(ExtractWord(2,Address,FidoChars));
  Node:=CToN(ExtractWord(3,Address,FidoChars));
  Point:=CToN(ExtractWord(4,Address,FidoChars));
  if LongBox then FileBox:=AddBackSlash(AddBackSlash(BaseDir))+NToC(zone)+'.'+NToC(net)+'.'+NToC(node)+'.'+NToC(point) else
  FileBox:=AddBackSlash(AddBackSlash(BaseDir))+
           FromDec(Zone,32,2)+
           FromDec(Net,32,3)+
           FromDec(Node,32,3)+
           '.'+FromDec(Point,32,2);
 end;
{}
function    HoldFileBox(BaseDir,Address: String; LongBox: Boolean): String;
 begin
 if LongBox then HoldFileBox:=FileBox(BaseDir,Address,True)+'.H'
 else HoldFileBox:=FileBox(BaseDir,Address,False)+'H';
 end;
{}
function    CheckMaskAddress(Mask, AddrStr: String): Boolean;
 var
  aZone,aNode,aNet,aPoint: String[5];
  nZone,nNode,nNet,nPoint: String[5];
 begin
  Mask:=DeTruncateAddr(Mask);
  AddrStr:=DeTruncateAddr(AddrStr);
  aZone:=ExtractWord(1,AddrStr,FidoChars);
  aNet:=ExtractWord(2,AddrStr,FidoChars);
  aNode:=ExtractWord(3,AddrStr,FidoChars);
  aPoint:=ExtractWord(4,AddrStr,FidoChars);

  nZone:=ExtractWord(1,Mask,FidoChars);
  nNet:=ExtractWord(2,Mask,FidoChars);
  nNode:=ExtractWord(3,Mask,FidoChars);
  nPoint:=ExtractWord(4,Mask,FidoChars);

  CheckMaskAddress:=
   (
    ((aZone =nZone ) or (CompName(nZone,aZone))) and
    ((aNet  =nNet  ) or (CompName(nNet,aNet))) and
    ((aNode =nNode ) or (CompName(nNode,aNode))) and
    ((aPoint=nPoint) or (CompName(nPoint,aPoint)))
   );
 end;
{}
function    ItAddrMask(Addr: String): Boolean;
 var
  aZone,aNode,aNet,aPoint: String[5];
  res: Boolean;
 begin
  aZone:=ExtractWord(1,Addr,FidoChars);
  aNet:=ExtractWord(2,Addr,FidoChars);
  aNode:=ExtractWord(3,Addr,FidoChars);
  aPoint:=ExtractWord(4,Addr,FidoChars);
  Res:=(Pos(Star,aZone)<>0) or
       (Pos(Star,aNet) <>0) or
       (Pos(Star,aNode)<>0) or
       (Pos(Star,aPoint)<>0);
  ItAddrMask:=Res;
 end;
{}
function TruncateAddr(s: String): String;
 var
  n: Word;
 begin
  n:=CToN(ExtractWord(4,s,FidoChars));
  if (n=0) and (Pos('.',s)>0) then TruncateAddr:=Copy(s,1,Pos('.',s)-1) else TruncateAddr:=s;
 end;
{}
function DeTruncateAddr(s: String): String;
 var
  n: Word;
 begin
  n:=CToN(ExtractWord(4,s,FidoChars));
  if (n=0) and (Pos('.',s)<=0) then DeTruncateAddr:=s+'.0' else DeTruncateAddr:=s;
 end;
{}
end.
